/*	math.h	4.6	9/11/85	*/

/* Copyright (c) 1988, 1992 NeXT Computer, Inc. */

#ifndef _ANSI_MATH_H
#define _ANSI_MATH_H

#include <standards.h>

#ifdef __STRICT_BSD__
extern int errno;
#elif defined(_NEXT_SOURCE)
#import <errno.h>
#endif

#ifdef _NEXT_SOURCE
/* Match definition in <sys/types.h>. */
#define	EDOM		33		/* Argument outside function domain. */
#define	ERANGE		34		/* Result unrepresentable as double. */
#endif /* _NEXT_SOURCE */

#ifndef __STRICT_ANSI__
extern double __const__ asinh(double x);
extern double __const__ acosh(double x);
extern double __const__ atanh(double x);
extern double __const__ hypot(double x, double y);
extern double cabs();	/* `cabs' can't be prototyped reasonably. */
extern double __const__ cbrt(double x);
extern double __const__ expm1(double x);
extern double __const__ log1p(double x);
extern double __const__ lgamma(double x);
extern double rint(double x);

/* Error functions. */
extern double __const__ erf(double x);
extern double __const__ erfc(double x);

/* Bessel functions. */
extern double __const__ j0(double x);
extern double __const__ j1(double x);
extern double __const__ jn(int n, double x);
extern double __const__ y0(double x);
extern double __const__ y1(double x);
extern double __const__ yn(int n, double x);

/* IEEE 754 support. */
extern double copysign(double x, double y);
extern double drem(double x, double y);
extern int finite(double x);
extern double logb(double x);
extern double scalb(double x, int n);
#endif	/* !__STRICT_ANSI__ */

#if defined(__STRICT_ANSI__) || defined(_NEXT_SOURCE)
extern double __const__ acos(double x);
extern double __const__ asin(double x);
extern double __const__ atan(double x);
extern double __const__ atan2(double y, double x);
extern double __const__ cos(double x);
extern double __const__ sin(double x);
extern double __const__ tan(double x);
extern double __const__ cosh(double x);
extern double __const__ sinh(double x);
extern double __const__ tanh(double x);
extern double __const__ exp(double x);
extern double frexp(double value, int *exp);
extern double __const__ ldexp(double x, int exp);
extern double __const__ log(double x);
extern double __const__ log10(double x);
extern double modf(double value, double *iptr);
extern double __const__ pow(double x, double y);
extern double __const__ sqrt(double x);
extern double __const__ ceil(double x);
extern double __const__ fabs(double x);
extern double __const__ floor(double x);
extern double __const__ fmod(double x, double y);
#endif /* __STRICT_ANSI__ || _NEXT_SOURCE */

/* Import architecture specific math definitions. */

#include <ansi/machine/math.h>

#endif /* _ANSI_MATH_H */
